/*
 * imidas98.c
 * imidas '98 uC~_X J^JiEꎫTv
 * f[^eLXg[eBeB
 * Copyright (C) 2003 by Masashi Suzuto
 */

#include <stdio.h>
#include <stdlib.h>

const SizeHeader = 4;
const SizeIndex = 8;
const NumIndex = 23742;

void main(int argc, char* argv[]) {
	FILE *fp_in, *fp_out;
	int i, j, index_num, index_vol;
	char text[768];
	int t[4] = { 0x119, 0x11A, 0x112, 0x104 };

	if( argc < 3 ){
		perror("t@Cw肵ĂB\n");
		exit(1);
	}

	if( (fp_in = fopen(argv[1], "rb") ) == NULL ) {
		perror("Can't file open!\n");
		exit(1);
	}

	if( (fp_out = fopen(argv[2], "wb") ) == NULL ) {
		perror("Can't file open!\n");
		exit(1);
	}

	for ( i = 0; i < NumIndex; i++ ) {
		fseek( fp_in, SizeIndex * i + SizeHeader, SEEK_SET );
		fread( &index_num, sizeof(index_num), 1, fp_in );
		fread( &index_vol, sizeof(index_vol), 1, fp_in );
		fseek( fp_in, index_num, SEEK_SET );
		fread( &text, index_vol, 1, fp_in );
		for ( j = 0; j < index_vol; j++ ) {
			text[j] = t[j & 3] - text[j];
			if ( text[j] == 13 ) { /* 0x0D */
				text[j] = '\n';
				if ( (j & 3) == 1 || (j & 3) == 2 ) {
					text[j-1] = text[j-1] + 1;
				}
			}
		}
		fwrite( text, index_vol - 3, 1, fp_out );
		fprintf( fp_out, "D\n" );   
	}
	fclose(fp_in);
	fclose(fp_out);
}
